// email_list.js

// Specifications
// <html> underscore_case -> js camelCase

// init -> load -> ready

// javascript constant variable assignment
// const $ = "assign function"

// jQuery
$(document).ready(

    // define function for param of ready()
    // function will not be passed ANY args -> params
    // es6 arrow function encapsulated script version 6 javascript
    () =>  {

        // handle the click on the Join List button
        $("#join_list").click(

            // define an es6 arrow function for the click event (evt)
            evt => {

                let isValid = true; 
                // in chapter 1 example we used javascript
                // here, we will use jQuery

                // Email1
                // pattern validation chars@chars.chars jQuery test()
                // value cleanup jQuery trim() -> remove whitespace beg and end value
                // replace the * with the error if not valid  jQuery next().text("replace with string") "find and replace"
                // email_address1234@domain.com
                // /\b[a-zA-Z0-9._]+@[a-zA-Z0-9.-]+\.[a-zA-Z0-9]{2,8}\b/
                const emailPattern = /\b[a-zA-Z0-9._]+@[a-zA-Z0-9.-]+\.[a-zA-Z0-9]{2,8}\b/;

                // strip out the whitespace from the email_1 value
                // value() from chapter 1 javascript
                // jQuery val()
                const email1 = $("#email_1").val().trim(); // clean value from the user input on the html form
                // lower case, trim whitespace, ...

                // test the cleanzed value email1 against our pattern emailPattern
                if ( email1 == "" ) {
                    $("#email_1").next().text("This field is required.");
                    isValid = false;
                }
                // there is a value -> now test the pattern
                else if ( !emailPattern.test(email1) ) {
                    $("#email_1").next().text("This is not a valid email address.");
                    isValid = false;
                }
                else {
                    $("#email_1").next().text("*");
                    // leave the isValid = true
                }

                // store the "validated email1 from the form"
                $("#email_1").val(email1);


                // Email2
                // repeat the requirements from email1 and add a relational op to see if email2 == email1 using != principle


                // First Name
                // validate the chars in First Name != Null


                // Zip Code
                // DRY Principle
                // LBYL vs EAFP Principle
                // Law of Demeter Principle
                /// option 2 so we don't repeat the else if is to use a test(pattern)
                /// zipCodePattern = /\b[0-9]{5}\b/
                /// zipCodePattern.test(zipCode)

                /// option 1 if else if else if else
                // required, trim(), isNaN(), length !=5
                const zipCode = $("#zip_code").val().trim()

                // required
                if ( zipCode == "") {
                    $("#zip_code").next().text("Zip Code is required");
                    isValid = false;
                }
                // check to see if the entry is not a number
                else if ( isNaN(zipCode) ) {
                    $("#zip_code").next().text("Zip Code must be a number in 5 digit format");
                    isValid = false;
                }
                // use the length attr to test for not 5 digits
                else if ( zipCode.length != 5 ) {
                    $("#zip_code").next().text("Zip Code must be in 5 digit format");
                    isValid = false;
                }
                else {
                    $("#zip_code").next().text("*");
                }
                $("#zip_code").val(zipCode)


                // Prevent the F5 default POM refresh so we don't loose the data already valid in the form.
                if (isValid == false) {
                    evt.preventDefault();
                } // if

            } // evt

        ); // join_list()


        // handle the button reset on the form
        /// 1. clear the values from the elements on the form
        /// 2. remove any errors from prior elements (required, not valid, ...)
        /// 3. set the jQuery focus() to email_1
        $("#reset").click(

            () => {

                // clear the elements
                $("#email_1").val("");
                $("#email_2").val("");
                $("#first_name").val("");

                // reset any error codes text
                $("#email_1").next().text("*");
                $("#email_2").next().text("*");
                $("#first_name").next().text("*");

                // set the jQuery focus() to email_1
                $("#email_1").focus();

            } // event

        ); // reset click()

        // function to set the ready focus() to email1
        $("#email_1").focus();

    } // es6 arrow function param 1
); // ready()

// EOF email_list.js