// future_value.js

// loops -> control variable (continue/break), condition (tests the input against the control variable), operation (expressions/actions to be done)

// control variable to handle the user action
let again = "y";

// do while statement will create a condition and operations when the control variable is "y"

do { // parent do/while is the user control

    // step 1 -> get the investment amount, test for a number and if the user does not enter a number loop back to the prompt
    // number -> float(10.2552) or int(10000)
    // number -> float 10.25
    // string -> "10.25"
    // new concepts -> isNan(isNot a Number), || (or logical operator), prompt(), parseFloat()
    // all user inputs by default are strings, we are going to use parseFloat() to convert the string input to a float(for the arithmetic operation)

    /// define the investment variable and assign the default value
    let investment = 0;
    /// do the prompt, conversion to float and the test for not a number
    do {
        investment = parseFloat(
                // ask the user for their investment amount
                prompt("Enter investment amount (minimum 10000.00)", 10000)
        );
    } while (
        isNaN(investment) || investment < 10000
    ); // do/while for the investment value

    // step 2 -> get the interest rate, test for a number and if the user does not enter a number loop back to the prompt
    // new concepts -> using MULTIPLE logical operations || || -> if the test variable is the same, you MUST call the variable in both operations
    /// isNaN(rate) || rate <= 0 || rate > 15
    let rate = 0;
    do {
        rate = parseFloat(
            prompt(
                "Enter interest rate (enter 7.5% as 7.5)", 
                7.5
            ) // prompt()
        ); // parseFloat()
    } // do{rate}
    while (
        isNaN(rate) || rate <= 0 || rate > 15
    ); // while(rate)


    // step 3 -> get the number of years for the investment, test for a number and if the user does not enter a number loop back to the prompt
    // new concept -> parseInt()
    let years = 0; // HAS TO BE a whole number aka Integer
    do {
        years = parseInt(
            prompt(
                "Enter number of years as a whole number (max 10 years)",
                10
            ) // prompt()
        ); // parseInt()
    } // do{years}
    while (
        isNaN(years) || years <= 0 || years > 10
    ); // while(years)

    // step 4 -> display the values entered on the screen
    // new concepts -> ${template variable}, write(write results to a DOM using a tick for the output), tick to wrap the string output
    document.write(
        `<h4>Investment Amount = $${investment} Interest Rate = ${rate}% Year = ${years}</h4>`
    ); // write()

    // step 5 -> calculate the investment
    // new concepts -> for loop to show each years investment in a row, arithmetic operations, knowledge of DIVIDEBYZERO error, fix the number of decimal places of our numbers to (2) using to toFixed() function
    let futureValue = investment; // year 1's value is the start of the investment amount

    /// for (control variable; condition; operation)
    for ( let y = 1; y <= years; y++) {

        // arithmetic operations to calculate interest
        const interest = futureValue * rate / 100; // order of precedence, can't divide a number by zero
        /// 10000 * 7.5 / 100 = 750
        /// const interest = 750
        futureValue = futureValue + interest; // 10750 = 10000 + 750

        /// Year Rolling Profit
        let profitLoss = futureValue - investment;

        /// write the row to the html
        //// Year 1 Earned Interest $750 End of Year Value $10750
        document.write(`<p>Year ${y} Interest Earned $${interest.toFixed(2)} End of Year Value $${futureValue.toFixed(2)} <strong>Profit/Loss $${profitLoss.toFixed(2)}</strong></p>`);

    } // for

    // ask the user in the last step if they want to do this again
    // if y = continue
    // if !y = break
    again = prompt("Repeat investment options? (y/n)", "y")
    // ? continue or break from the parent do
} // do

while ( again == "y") // back to the do, else break to the next line of code

// display the results of the investment in the browser
document.write(html)

// EOF future_value.js