// faqs.js

// init(compiler) -> well formatted html<css/js> -> browser(load) -> ready()

$(document).ready( () => {

    // runs when an h2 heading is clicked #faqs plus/minus
    $("#faqs h2").click(
        // at this point, the plus was loaded by default by the page
        // create an event that toggles the class to minus h2.minus (css)
        evt => {

            const h2 = evt.currentTarget;

            $(h2).toggleClass("minus");
            // <h2 id="#faqs" class="plus"> -> the ready status
            // toggle it to <h2 id="#faqs" class="minus"> -> change the image

            // easeIn and easeOut animation using jQuery
            // always test to see if you want to do something
            if ($(h2).attr("class") != "minus") {
                // easeIn
                $(h2).next().slideUp(1000, "easeInBounce");
            }
            else {
                //easeOut
                $(h2).next().slideDown(1000, "easeOutBounce");
            }

            evt.preventDefault(); // do not want the POM refresh F5 

        } //evt

    ); // click()

    // runs when the page is in ready status h1 tag #faqs with some animation
    $("#faqs h1").animate({
        // set {} of key:value
        fontSize: "650%",
        opacity: 1,
        left: "+=375"
        },
        1000
    ) // animate(650%)
    .animate({
        fontSize: "175%",
        left: 0
    }, 1000 ); // animate(175%)


    // runs when any top level heading h1 tag #faqs is clicked some animation
    // <h1 id="faqs"> -> onClick()
    $("#faqs h1").click( () => {

        // same action as the ready, with a 2000 load on the click
        $("#faqs h1").animate({
            // set {} of key:value
            fontSize: "650%",
            opacity: 1,
            left: "+=375"
            },
            2000
        ) // animate(650%)
        .animate({
            fontSize: "175%",
            left: 0
        }, 1000 ); // animate(175%)

    } // function
    ); // click


} // event function
); // ready()


// EOF faqs.js